#include "SDL.h"
#include "gl.h"
#include "glu.h"

#include <iostream.h>
#include <math.h>

#include <stdio.h>
#include <stdlib.h>

#include <fstream>
#include <string.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

using namespace std;//ХЗ что это но с ним заработал строковый тип string

int i;

SDL_Surface *screen;
SDL_Surface *surface; //SDL поверхность

GLuint texture[3]; // Хэндл основных текстурных объектов-текстуры основных объектов

TTF_Font *fonts[3] = {NULL,NULL,NULL};

bool writeTxt(TTF_Font *font, SDL_Color textColor,const char text[], GLuint texture, bool center);
bool load(string file, GLuint &tex);

void gl2dMode (int dW,int dH);
void DrawSPR (int x,
              int y,
              int dX,
              int dY,
              int delta);


int main()
{
    //Инициализация SDL(видео) 
    if ( SDL_Init(SDL_INIT_VIDEO) != 0 ) 
     {
      printf("Unable to initialize SDL: %s\n", SDL_GetError());
      return 1;
     }


    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 ); // ХЗ

    screen = SDL_SetVideoMode( 1024, 768, 32, SDL_OPENGL/* | SDL_FULLSCREEN*/ ); // задаем экран OpenGl
    if ( !screen ) 
     {
      printf("Unable to set video mode: %s\n", SDL_GetError());
      return 1;
     }
	
    // Текст и  иконка в титульнике окна программы
    SDL_WM_SetCaption("Game Edit","edit");
    SDL_WM_SetIcon(SDL_LoadBMP("icon.bmp"), NULL);

    // Цвет текста 
    SDL_Color txtColorRed = {255,0,0};
    SDL_Color txtColorGreen = {0,255,0};
    SDL_Color txtColorBlue = {0,0,255};
    SDL_Color txtColorWhite = {255,255,255};
    SDL_Color txtColorBlack = {0,0,0};

    TTF_Init();//инициализируем шрифт
        
    //Массив фонтов, задаем шрифт и болд
    fonts[1] = TTF_OpenFont( "font1.ttf", 150 );//открываем фонт
    fonts[2] = TTF_OpenFont( "font2.ttf", 150 );//открываем фонт 
    fonts[3] = TTF_OpenFont( "font3.ttf", 150 );//открываем фонт

    //Устанавливаем режим для OpenGL

    //Задний цвет фона зеленый (R,G,B,alpha)
    glClearColor( 0, 20, 60, 0 );
	
    glEnable( GL_TEXTURE_2D ); // надо для вывода текстуры

    gl2dMode (1024,768);

 
    //Включаем альфа канал
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);



/*
  //===Загружаем текстуры===
  char buffer[200];//для загрузки уровня
  for(i=1;i<3+1;i++)
   {
    sprintf(buffer,"image%i.bmp",i);
    if (surface = SDL_LoadBMP(buffer))  
     { 
      //Генерим GL-вскую текстуру
      glGenTextures(1, &texture[i]);
      glBindTexture( GL_TEXTURE_2D, texture[i] );
   
      //Растягиваем текстуру 

      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
      //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

      //Текстура использует информация с поверхности SDL 
      glTexImage2D( GL_TEXTURE_2D, 0, 3, surface->w, surface->h, 0, 
                    GL_BGR, GL_UNSIGNED_BYTE, surface->pixels );
     } 
    else //иначе выходим с ошибкой 
     {
      printf("Image not load: %s\n", SDL_GetError());
      SDL_Quit();
      return 1;
     }    
    
   }//конец цикла загрузки текстур

   //Если все в норме освобождаемся от поверхности
   if ( surface ) 
    { 
     SDL_FreeSurface( surface );
    }
   //==Конец загрузки текстур==//
   
*/

    load("image2.jpg", texture[1]);
    load("test.png", texture[2]);
    load("9.tga", texture[3]);

    //Очищаем экран перед рисованием
    glClear( GL_COLOR_BUFFER_BIT );
   
// выводим текст
    GLuint t_txt[30];
    int chislo;
    char txt_tmp[25];
    chislo=1111;
    sprintf(txt_tmp,"%i",chislo);

// выводим число
    glGenTextures(1, &t_txt[1]);
    writeTxt(fonts[1],txtColorBlack,txt_tmp, t_txt[1],1);
    glBindTexture( GL_TEXTURE_2D, t_txt[1] );
    DrawSPR (200,100,200,100,-20);     

// выводим просто текст
    glGenTextures(1, &t_txt[2]);
    writeTxt(fonts[2],txtColorBlack,"PIZDEC!", t_txt[2],1);
    glBindTexture( GL_TEXTURE_2D, t_txt[2] );
    DrawSPR (400,150,200,100,20);     

    glGenTextures(1, &t_txt[3]);
    writeTxt(fonts[3],txtColorBlack,"PIZDEC!", t_txt[3],1);
    glBindTexture( GL_TEXTURE_2D, t_txt[3] );
    DrawSPR (600,150,200,100,20);     

    glGenTextures(1, &t_txt[4]);
    writeTxt(fonts[3],txtColorBlack,"PIZDEC!", t_txt[4],1);
    glBindTexture( GL_TEXTURE_2D, t_txt[4] );
    DrawSPR (400,550,200,100,-20);     



    //Натягиваем текстуру и рисуем спрайт   
    glBindTexture( GL_TEXTURE_2D, texture[1] );
    DrawSPR (200,250,228,128,10);

    glBindTexture( GL_TEXTURE_2D, texture[2]);
    DrawSPR (250,280,228,128,20);

    glBindTexture( GL_TEXTURE_2D, texture[3] );
    DrawSPR (360,290,228,128,30);

    SDL_GL_SwapBuffers();
    
    // Задержка в 3 секунды
    SDL_Delay(3000);
    
    // Теперь можно стереть все сгенеренные текстуры и отключить SDL
    glDeleteTextures( 1, &texture[1] );
    glDeleteTextures( 1, &texture[2] ); 
    glDeleteTextures( 1, &texture[3] );  
  
    SDL_Quit();
    
    return 0;
}

void gl2dMode (int dW, int dH)
 {
   // glViewport( 0, 0, dW, dH );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    glOrtho( 0, dW, dH, 0, -1, 1 );
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
 }
    


void DrawSPR (int x,
              int y,
              int dX,
              int dY,
              int delta)
 {
    glLoadIdentity();
    glTranslatef(x,y,0);   
    glRotatef(delta,0,0,-1); 
    glTranslatef(-dX/2,-dY/2,0);

    glBegin( GL_QUADS );
        // Верхний левый угол
        glTexCoord2i(0,0);      glVertex3f( 0, 0, 0 );
        //Нижний левый угол
        glTexCoord2i( 0, 1 );   glVertex3f( 0, dY, 0 );
        //Нижний правый угол
        glTexCoord2i( 1, 1 );   glVertex3f( dX, dY, 0 );
        //Верхний правый угол
        glTexCoord2i( 1, 0 );   glVertex3f( dX, 0, 0 );
    glEnd();
 } 

bool load(string file, GLuint &tex)
 {
  SDL_Surface *temp = NULL;
  GLint maxTexSize;
  GLuint glFormat = GL_RGBA;
      
  if(file.substr(file.length()-3,3).compare("jpg") == 0)
   {
    glFormat = GL_RGB;
   }
      
  glGetIntegerv(GL_MAX_TEXTURE_SIZE, &maxTexSize); 

  temp = IMG_Load(file.data());

  if(temp == NULL)
   {
    cout << "Texture manager ERROR: " << file << " : "<< SDL_GetError() << endl;
    SDL_FreeSurface( temp );
    return 0;
   }
      
  if(temp->w > maxTexSize)
   {
    cout << "Texture manager ERROR: " << file << " texturesize too large." << endl;
   }
 
  glGenTextures(1, &tex);
  glBindTexture(GL_TEXTURE_2D, tex);

  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

  glTexImage2D(GL_TEXTURE_2D, 0, glFormat, temp->w, temp->h, 0, glFormat, GL_UNSIGNED_BYTE, temp->pixels);
  SDL_FreeSurface( temp );

  return 1;
}

bool writeTxt(TTF_Font *font, SDL_Color textColor,const char text[], GLuint texture, bool center)
{
  SDL_Surface *temp,*tempb;

  Uint32 rmask, gmask, bmask, amask;
  #if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
  #else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
  #endif

  if(font == NULL)
  {
    cout << SDL_GetError() << endl;;
    SDL_FreeSurface(temp);
    SDL_FreeSurface(tempb);
    return(false);
  }

  temp = TTF_RenderText_Blended(font, text, textColor);
  SDL_SetAlpha(temp, 0, 0);

  tempb = SDL_CreateRGBSurface(0, 512, 512, 32, rmask,gmask,bmask,amask);

  int w,h;
  TTF_SizeUTF8(font,text, &w,&h);
  
  SDL_Rect src,dst;
  src.x=0;
  src.y=0;
  src.w=w;
  src.h=h;

  if(center)
  {
    dst.x=(512.0-w)/2.0;
  } else {
    dst.x=0;
  }
  dst.y=0;
  dst.w=w;
  dst.h=h;

  SDL_BlitSurface(temp, &src, tempb, &dst);
  glBindTexture(GL_TEXTURE_2D, texture);
  gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, tempb->w, tempb->h, GL_RGBA, GL_UNSIGNED_BYTE, tempb->pixels);

  SDL_FreeSurface(temp);
  SDL_FreeSurface(tempb);
  return(true);
}

